#define __SFR_OFFSET 0
#define io(reg) _SFR_IO_ADDR(reg)
#define mem(reg) _SFR_MEM_ADDR(reg)
#include "avr/io.h"

.global main

.text
main:                         ldi r18, 80
                              out SPCR, r18
                              ldi r18, 4
                              out DDRB, r18
                              ldi r18, 4
                              out PORTB, r18
                              ldi r18, 0
                              out DDRD, r18
                              ldi r18, 255
                              out PORTD, r18
                              ldi r18, 1
                              mov r2, r18
                              ldi r18, 3
                              mov r3, r18
                              ldi r18, 3
                              mov r4, r18
                              ldi r18, 3
                              mov r5, r18
                              ldi r18, 3
                              mov r6, r18
                              ldi r18, 1
                              mov r7, r18

loop:                         mov r18, r3
                              cpi r18, 1
                              brne 1f
                              ldi r19, 1
                              mov r7, r19
                              1:      cpi r18, 8
                                      brne 2f
                                      ldi r19, -1
                                      mov r7, r19
                              2:      mov r18, r2
                                      cpi r18, 1
                                      brne 1f
                                      ldi r19, 1
                                      mov r6, r19
                              1:      cpi r18, 14
                                      brne 2f
                                      ldi r19, -1
                                      mov r6, r19
                              2:      add r3, r7
                                      add r2, r6
                              1:      nop
                                      call frameClear
                                      mov r18, r2 
                                      cpi r18, 8
                                      brsh 1f
                                      ldi ZL, lo8(frameSegment1)
                                      ldi ZH, hi8(frameSegment1)
                                      mov r19, r2
                                      inc r19
                                      ldi r20, 0
                                      bset 0
                              3:      rol r20
                                      bclr 0
                                      dec r19
                                      brne 3b
                                      jmp 2f
                              1:      ldi ZL, lo8(frameSegment2)
                                      ldi ZH, hi8(frameSegment2)
                                      mov r19, r2
                                      subi r19, 7
                                      ldi r20, 0
                                      bset 0
                              3:      rol r20
                                      bclr 0
                                      dec r19
                                      brne 3b
                              2:      add ZL, r3
                                      adc ZH, r1
                                      st -Z, r20
                              ldi ZL, lo8(frameSegment1)
                              ldi ZH, hi8(frameSegment1)
                              add ZL, r4
                              adc ZH, r1
                              ld r20, -Z
                              ori r20, 1
                              st Z+, r20
                              ld r20, Z
                              ori r20, 1
                              st Z+, r20
                              ld r20, Z
                              ori r20, 1
                              st Z, r20
                              ldi ZL, lo8(frameSegment2)
                              ldi ZH, hi8(frameSegment2)
                              add ZL, r5
                              adc ZH, r1
                              ld r20, -Z
                              ori r20, 128
                              st Z+, r20
                              ld r20, Z
                              ori r20, 128
                              st Z+, r20
                              ld r20, Z
                              ori r20, 128
                              st Z, r20
                              call frameOut
                              call BarPlayer1
                              ldi r24, 120
                              call delay
                              call BarPlayer2
                              ldi r24, 120
                              call delay
                              mov r18, r2
                              cpi r18, 1
                              brne 1f
                              cp r3, r4
                              brsh 2f
                              jmp 3f
                              2:      mov r18, r4
                                      inc r18
                                      inc r18
                                      inc r18
                                      cp r3, r18 
                                      brlo 1f
                              3:      call playTune
                                      ldi r24, 255 
                                      call delay
                                      ldi r24, 255 
                                      call delay
                                      ldi r24, 255 
                                      call delay
                                      ldi r24, 255 
                                      call delay
                                      jmp main
                              1:      nop
                              mov r18, r2
                              cpi r18, 14
                              brne 1f
                              cp r3, r5
                              brsh 2f
                              jmp 3f
                              2:      mov r18, r5
                                      inc r18
                                      inc r18
                                      inc r18
                                      cp r3, r18 
                                      brlo 1f
                              3:      call playTune
                                      ldi r24, 255 
                                      call delay
                                      ldi r24, 255 
                                      call delay
                                      ldi r24, 255 
                                      call delay
                                      ldi r24, 255 
                                      call delay
                                      jmp main
                              1:      nop
                              jmp loop
                              jmp main

BarPlayer1:                   sbis PIND, 3
                              dec r4
                              sbis PIND, 4
                              inc r4
                              mov r18, r4
                              cpi r18, 1
                              brsh 2f
                              ldi r18, 1
                              mov r4, r18
                              brsh 1f
                              2:      mov r18, r4
                                      cpi r18, 6
                                      brlo 1f
                                      ldi r18, 6
                                      mov r4, r18
                              1:      ret

BarPlayer2:                   sbis PIND, 6
                              dec r5
                              sbis PIND, 7
                              inc r5
                              mov r18, r5
                              cpi r18, 1
                              brsh 2f
                              ldi r18, 1
                              mov r5, r18
                              brsh 1f
                              2:      mov r18, r5
                                      cpi r18, 6
                                      brlo 1f
                                      ldi r18, 6
                                      mov r5, r18
                              1:      ret

spiOut:			      out SPDR, r24
                              1:      in r0, SPSR
                                      sbrs r0, SPIF
                                      rjmp 1b
                                      ret

frameOut:                     ldi r18, 1
                              ldi ZL, lo8(frameSegment1)
                              ldi ZH, hi8(frameSegment1)
                              ldi YL, lo8(frameSegment2)
                              ldi YH, hi8(frameSegment2)
                              1:      ldi r19, 0
                                      out PORTB, r19
                              mov r24, r18
                              rcall spiOut
                              ld r24, Z+
                              rcall spiOut
                              mov r24, r18
                              rcall spiOut
                              ld r24, Y+
                              rcall spiOut
                              ldi r19, 4
                              out PORTB, r19
                              inc r18
                              cp r18, 8
                              brne 1b
                              ret

frameClear:                   ldi ZL, lo8(frameSegment1)
                              ldi ZH, hi8(frameSegment1)
                              ldi YL, lo8(frameSegment2)
                              ldi YH, hi8(frameSegment2)
                              ldi r18, 8
                              ldi r19, 0
                              1:      st Z+, r19
                                      st Y+, r19
                                      dec r18
                                      brne 1b
                                      ret

playTune:                     _a = 141
                              ldi r16, 0b00100011
                              out mem(TCCR0A), r16
                              ldi r16, 0b00001100
                              out mem(TCCR0B), r16
                              ldi r16, 141
                              out io(OCR0A), r16
                              ldi r16, 71
                              out io(OCR0B), r16
                              sbi io(DDRD), 5
                              ret

delay:                        ldi r26, 1200 & 255
                              ldi r27, 1200 >> 8
                              1:      sbiw r26, 1
                                      brne 1b
                                      sbiw 24, 1
                                      brne delay
                                      ret
                                      
.data
frameSegment1:                .space 8
frameSegment2:                .space 8